Redacted Fields in the Registration Data Access Protocol (RDAP) Response
Internet-Draft draft-ietf-regext-rdap-redacted-09
James Gould
VeriSign, Inc.
12061 Bluemont Way
Reston
VA
20190
US
jgould@verisign.com
http://www.verisigninc.com
David Smith
VeriSign, Inc.
12061 Bluemont Way
Reston
VA
20190
US
dsmith@verisign.com
http://www.verisigninc.com
Jody Kolker
GoDaddy Inc.
14455 N. Hayden Rd. #219
Scottsdale
AZ
85260
US
jkolker@godaddy.com
http://www.godaddy.com
Roger Carney
GoDaddy Inc.
14455 N. Hayden Rd. #219
Scottsdale
AZ
85260
US
rcarney@godaddy.com
http://www.godaddy.com
Redacted
Redaction
Redacting
JSONPath
This document describes an RDAP extension for explicitly identifying redacted RDAP response fields, using JSONPath as the default expression language.
Introduction
This document describes an RDAP extension for explicitly identifying redacted RDAP response fields, using JSONPath as the default expression language. A redacted RDAP field is one that has data removed or replaced in the RDAP response due to server policy, such as the lack of client privilege to receive the field. This extension can be used to identify redacted RDAP fields in any RDAP object class, as defined in [RFC9083], or RDAP fields defined in RDAP extensions. Because an RDAP response may exclude a field due to either the lack of data or based on the lack of RDAP client privileges, this extension is used to explicitly specify which RDAP fields are not included in the RDAP response due to redaction. It thereby provides a capability for disambiguation between redaction and possible other reasons for data or field absence.
In [RFC9082] RDAP supports both lookup and search queries, where a lookup query responds with a single object and a search query responds with a list of objects. This document applies to redaction of a single object of a lookup response and in each of the objects of a search response.
JSONPath, as defined in [I-D.ietf-jsonpath-base], is used as the default expression language to reference RDAP fields that have been redacted. The redacted JSON fields will either be removed or have empty values in the RDAP response. JSON is defined by [RFC8259].
Conventions Used in This Document
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
The JSON examples include extra line breaks and whitespace. For instance, the JSONPath expressions are broken out into multiple lines when required for illustration.
Redaction Methods
Redaction in RDAP can be handled in multiple ways. The use of placeholder text for the values of the RDAP fields, such as the placeholder text "XXXX", MUST NOT be used for redaction. A placeholder text value will not match the format requirements of each of the RDAP fields and provides an inconsistent and unreliable redaction signal. This section covers the redaction methods that can be used with the redaction signaling defined in Section 4.2.
RDAP responses, as defined in [RFC9083], include a mix of JSON objects and JSON arrays, where JSON arrays are heavily used for entity objects with jCard. jCard is a JSON representation of vCard that inherits its dependency on arrays. An example is the vCard "ADR" property / jCard "adr" property that defines a sequence of address components. According to [RFC6350], when an "ADR" property component value is missing, the associated component separator MUST still be specified. jCard extends the use of arrays with each individual vCard property being represented by an array of three fixed elements, followed by one or more additional elements. The mix of JSON objects and JSON arrays impacts the methods used for redaction in RDAP.
The redaction of RDAP fields fall into the three categories defined in the following sub-sections.
Redaction by Removal Method
The Redaction by Removal Method is when the RDAP field is removed from the RDAP response, which is the preferred method. The Redaction by Removal Method can be done for all RDAP response fields other than response fields using the position in an array to signal the redacted field (e.g., the JSON arrays used with jCard). RDAP extensions such as JSContact in Registration Data Access Protocol (RDAP) JSON Responses do not have a dependency on the use of positional JSON arrays and are therefore suited for the Redaction by Removal Method.
When an RDAP object is redacted by removal, all of the RDAP object's child fields are also removed. Only the redacted RDAP object needs to be referenced in the list of redacted fields, as defined in Section 4.2.
An example of redacting an RDAP object is removing the administrative contact from the RDAP response and including the following "redacted" member:
Redacted Administrative Contact

"redacted": [
  {
    "name": {
      "type": "Administrative Contact"
    },
    "path": "$.entities[?(@.roles[0]=='administrative')]",
    "method": "removal"
  }
]

The Redaction by Removal Method MUST NOT be used to remove a field using the position in a fixed length array to signal the redacted field. For example, removal of an individual data field in jCard will result in a non-conformant jCard array definition.
Redaction by Empty Value Method
The Redaction by Empty Value Method is when a redacted field is not removed, but its value is set to an empty value, such as "" for a jCard Text ("text") property or null for non-Text ("text") properties. The empty jCard values ("" or null) are referenced in the "redacted" member in place of the jCard property name, such as referencing the "fn" jCard property value at position 3 instead of referencing the "fn" jCard property name at position 0. The Redaction by Empty Value Method SHOULD be used only when redacting JSON response fields that use the position in an array to signal the redacted field (e.g., jCard arrays). Optional jCard properties SHOULD use the Redaction by Removal Method to redact the entire property. The required jCard "fn" property, defined in section 6.2.1 of vCard, MUST use the Redaction by Empty Value Method to redact the property value. Removing the "fn" property would violate vCard and removing the property value would violate the fixed array positions defined in jCard.
An example of the redacted "fn" jCard property using the Redaction by Empty Value Method:
Redacted "fn" jCard property using Redaction by Empty Value Method

[
  "fn",
  {},
  "text",
  ""
]

An example of the "redacted" member for the redacted "fn" jCard property value, which is array position 3:
Redacted Registrant Name using Array Position

"redacted": [
  {
    "name": {
      "type": "Registrant Name"
    },
    "path": "$.entities[?(@.roles[0]=='registrant')].
      vcardArray[1][?(@[0]=='fn')][3]",
    "pathLang": "jsonpath",
    "method": "emptyValue",
    "reason": {
      "type": "Server policy"
    }
  }
]

Redaction by Replacement Value Method
The Redaction by Replacement Value Method is when a redacted field is not removed, but its value is replaced with a different value, such as protecting the "email" jCard property value with an anonymized email "text" value or the use of an alternate "uri" value to a web form. Replacing a property value is a form of redaction, since it protects the true property value for privacy reasons.
An example of the redacted "email" jCard property using the Redaction by Replacement Value Method with an anonymized email:
Redacted "email" jCard property using Redaction by Replacement Value Method with an anonymized email

[
  "email",
  {},
  "text",
  "anonymized123@example.com"
]

An example of the "redacted" member for the redacted registrant "email" jCard property value with an anonymized "text" value.
Redacted Email using Replacement Value with an anonymized "text" value

"redacted": [
  {
    "name": {
      "type": "Registrant Email"
    },
    "path": "$.entities[?(@.roles[0]=='registrant')].
               vcardArray[1][?(@[0]=='email')][3]",
    "pathLang": "jsonpath",
    "method": "replacementValue",
  }
]

An example of the redacted "email" jCard property using the Redaction by Replacement Value Method with a [RFC8605] "contact-uri" jCard property to a web form:
Redacted "email" jCard property using Redaction by Replacement Value Method with a "contact-uri" jCard property to a web form

[
  "contact-uri",
  {},
  "uri",
  "https://email.example.com/123"
]

An example of the "redacted" member for the redacted registrant "email" jCard property value with a [RFC8605] "contact-uri" jCard property to a web form:
Redacted Email using Replacement Value with a "contact-uri" jCard property to a web form

"redacted": [
  {
    "name": {
      "type": "Registrant Email"
    },
    "path": "$.entities[?(@.roles[0]=='registrant')].
               vcardArray[1][?(@[0]=='email')][3]",
    "replacementPath": "$.entities[?(@.roles[0]=='registrant')].
               vcardArray[1][?(@[0]=='contact-uri')][3]",
    "pathLang": "jsonpath",
    "method": "replacementValue",
  }
]

Redacted RDAP Response
RDAP Conformance
RDAP responses that contain values described in this document MUST indicate conformance with this specification by including an "rdapConformance" ([RFC9083]) value of "redacted". The "redacted" extension identifier is described in Section 6.1.
Example "rdapConformance" member with the redacted extension:
"rdapConformance" with Redacted Extension

"rdapConformance": [
  "rdap_level_0",
  "redacted"
]

"redacted" Member
The "redacted" member MUST be added to the RDAP response when there is one or more redacted fields. The "redacted" member is included as a member of the object class in a lookup response, such as the object classes defined in [RFC9083], and as a member of the object instances in a search response, such as the object instances defined in [RFC9083]. The "redacted" member contains an array of redacted objects with the following child members:
"name":
A logical name for the redacted field. The logical name used for the redacted field is up to server policy. The logical name is defined using an object with a "type" field denoting a registered redacted name (see Section 6.2) or a "description" field denoting an unregistered redacted name. The registered redacted names and the chosen unregistered names can meet the needs of different RDAP services or industries.
"path":
The JSON expression references a removed JSON field in the case of Redaction By Removal Method, an empty field in the case of Redaction by Empty Value Method, or the field that is replaced in the case of Redaction by Replacement Value Method. The replaced field can be either removed or empty when using a replacement field referenced by the “replacementPath” member.
"replacementPath":
OPTIONAL JSON expression of the replacement field of the redacted field with the Redaction by Replacement Value Method, using the expression language defined by the "pathLang" member.
"pathLang":
OPTIONAL JSON path expression language used, with the default value of "jsonpath" for JSONPath ([I-D.ietf-jsonpath-base]). Other JSON path expression languages MAY be used based on server policy.
"method":
OPTIONAL redaction method used; with one of the following values:
- "removal" indicating the Redaction By Removal Method,
- "emptyValue" indicating the Redaction by Empty Value Method, or
- "replacementValue" indicating the Redaction by Replacement Value Method.
The default value is "removal" when not provided.
"reason":
OPTIONAL human readable reason(s) for the redacted field in the language defined by the [RFC9083] "lang" member. The default language is "en" if the [RFC9083] "lang" member is not specified. The reason is defined using an object with an OPTIONAL "type" field denoting a registered redacted reason (see see Section 6.2) and an OPTIONAL "description" field denoting an unregistered redacted reason. The "description" field MUST NOT be a client processing dependency.
Example unredacted version of an RDAP lookup response:
Unredacted RDAP Lookup Response

    {
      "rdapConformance": [
        "rdap_level_0"
      ],
      "objectClassName": "domain",
      "handle": "ABC123",
      "ldhName": "example.com",
      "secureDNS": {
        "delegationSigned": false
      },
      "notices": [
        {
          "title": "Terms of Use",
          "description": [
            "Service subject to Terms of Use."
          ],
          "links": [
            {
              "rel": "self",
              "href": "https://www.example.com/terms-of-use",
              "type": "text/html",
              "value": "https://www.example.com/terms-of-use"
            }
          ]
        }
      ],
      "nameservers": [
        {
          "objectClassName": "nameserver",
          "ldhName": "ns1.example.com"
        },
        {
          "objectClassName": "nameserver",
          "ldhName": "ns2.example.com"
        }
      ],
      "entities": [
        {
          "objectClassName": "entity",
          "handle": "123",
          "roles": [
            "registrar"
          ],
          "publicIds": [
            {
              "type": "IANA Registrar ID",
              "identifier": "1"
            }
          ],
          "vcardArray": [
            "vcard",
            [
              [
                "version",
                {},
                "text",
                "4.0"
              ],
              [
                "fn",
                {},
                "text",
                "Example Registrar Inc."
              ],
              [
                "adr",
                {},
                "text",
                [
                  "",
                  "Suite 100",
                  "123 Example Dr.",
                  "Dulles",
                  "VA",
                  "20166-6503",
                  "US"
                ]
              ],
              [
                "email",
                {},
                "text",
                "contact@organization.example"
              ],
              [
                "tel",
                {
                  "type": "voice"
                },
                "uri",
                "tel:+1.7035555555;ext=1234"
              ],
              [
                "tel",
                {
                  "type": "fax"
                },
                "uri",
                "tel:+1.7035555556"
              ]
            ]
          ],
          "entities": [
            {
              "objectClassName": "entity",
              "roles": [
                "abuse"
              ],
              "vcardArray": [
                "vcard",
                [
                  [
                    "version",
                    {},
                    "text",
                    "4.0"
                  ],
                  [
                    "fn",
                    {},
                    "text",
                    "Abuse Contact"
                  ],
                  [
                    "email",
                    {},
                    "text",
                    "abuse@organization.example"
                  ],
                  [
                    "tel",
                    {
                      "type": "voice"
                    },
                    "uri",
                    "tel:+1.7035555555;ext=1234"
                  ]
                ]
              ]
            }
          ]
        },
        {
          "objectClassName": "entity",
          "handle": "XXXX",
          "roles": [
            "registrant"
          ],
          "vcardArray": [
            "vcard",
            [
              [
                "version",
                {},
                "text",
                "4.0"
              ],
              [
                "fn",
                {},
                "text",
                "Registrant User"
              ],
              [
                "org",
                {},
                "text",
                "Example Inc."
              ],
              [
                "adr",
                {},
                "text",
                [
                  "",
                  "Suite 1235",
                  "4321 Rue Somewhere",
                  "Quebec",
                  "QC",
                  "G1V 2M2",
                  "Canada"
                ]
              ],
              [
                "email",
                {},
                "text",
                "registrant.user@example.com"
              ],
              [
                "tel",
                {
                  "type": "voice"
                },
                "uri",
                "tel:+1-555-555-1235;ext=123"
              ],
              [
                "tel",
                {
                  "type": "fax"
                },
                "uri",
                "tel:+1-555-555-5321"
              ]
            ]
          ]
        },
        {
          "objectClassName": "entity",
          "handle": "YYYY",
          "roles": [
            "technical"
          ],
          "vcardArray": [
            "vcard",
            [
              [
                "version",
                {},
                "text",
                "4.0"
              ],
              [
                "fn",
                {},
                "text",
                "Technical User"
              ],
              [
                "org",
                {},
                "text",
                "Example Inc."
              ],
              [
                "adr",
                {},
                "text",
                [
                  "",
                  "Suite 1234",
                  "4321 Rue Somewhere",
                  "Quebec",
                  "QC",
                  "G1V 2M2",
                  "Canada"
                ]
              ],
              [
                "email",
                {},
                "text",
                "technical.user@example.com"
              ],
              [
                "tel",
                {
                  "type": "voice"
                },
                "uri",
                "tel:+1-555-555-1234;ext=321"
              ],
              [
                "tel",
                {
                  "type": "fax"
                },
                "uri",
                "tel:+1-555-555-4321"
              ]
            ]
          ]
        },
        {
          "objectClassName": "entity",
          "handle": "ZZZZ",
          "roles": [
            "administrative"
          ],
          "vcardArray": [
            "vcard",
            [
              [
                "version",
                {},
                "text",
                "4.0"
              ],
              [
                "fn",
                {},
                "text",
                "Administrative User"
              ],
              [
                "org",
                {},
                "text",
                "Example Inc."
              ],
              [
                "adr",
                {},
                "text",
                [
                  "",
                  "Suite 1236",
                  "4321 Rue Somewhere",
                  "Quebec",
                  "QC",
                  "G1V 2M2",
                  "Canada"
                ]
              ],
              [
                "email",
                {},
                "text",
                "administrative.user@example.com"
              ],
              [
                "tel",
                {
                  "type": "voice"
                },
                "uri",
                "tel:+1-555-555-1236;ext=789"
              ],
              [
                "tel",
                {
                  "type": "fax"
                },
                "uri",
                "tel:+1-555-555-6321"
              ]
            ]
          ]
        },
        {
          "objectClassName": "entity",
          "handle": "WWWW",
          "roles": [
            "billing"
          ],
          "vcardArray": [
            "vcard",
            [
              [
                "version",
                {},
                "text",
                "4.0"
              ],
              [
                "fn",
                {},
                "text",
                "Billing User"
              ],
              [
                "email",
                {},
                "text",
                "billing.user@example.com"
              ]
            ]
          ]
        }
      ],
      "events": [
        {
          "eventAction": "registration",
          "eventDate": "1997-06-03T00:00:00Z"
        },
        {
          "eventAction": "last changed",
          "eventDate": "2020-05-28T01:35:00Z"
        },
        {
          "eventAction": "expiration",
          "eventDate": "2021-06-03T04:00:00Z"
        }
      ],
      "status": [
        "server delete prohibited",
        "server update prohibited",
        "server transfer prohibited",
        "client transfer prohibited"
      ]
    }

Example redacted version of an RDAP lookup response:
Redacted RDAP Lookup Response

    {
      "rdapConformance": [
        "rdap_level_0",
        "redacted"
      ],
      "objectClassName": "domain",
      "ldhName": "example.com",
      "secureDNS": {
        "delegationSigned": false
      },
      "notices": [
        {
          "title": "Terms of Use",
          "description": [
            "Service subject to Terms of Use."
          ],
          "links": [
            {
              "rel": "self",
              "href": "https://www.example.com/terms-of-use",
              "type": "text/html",
              "value": "https://www.example.com/terms-of-use"
            }
          ]
        }
      ],
      "nameservers": [
        {
          "objectClassName": "nameserver",
          "ldhName": "ns1.example.com"
        },
        {
          "objectClassName": "nameserver",
          "ldhName": "ns2.example.com"
        }
      ],
      "entities": [
        {
          "objectClassName": "entity",
          "handle": "123",
          "roles": [
            "registrar"
          ],
          "publicIds": [
            {
              "type": "IANA Registrar ID",
              "identifier": "1"
            }
          ],
          "vcardArray": [
            "vcard",
            [
              [
                "version",
                {},
                "text",
                "4.0"
              ],
              [
                "fn",
                {},
                "text",
                "Example Registrar Inc."
              ],
              [
                "adr",
                {},
                "text",
                [
                  "",
                  "Suite 100",
                  "123 Example Dr.",
                  "Dulles",
                  "VA",
                  "20166-6503",
                  "US"
                ]
              ],
              [
                "email",
                {},
                "text",
                "contact@organization.example"
              ],
              [
                "tel",
                {
                  "type": "voice"
                },
                "uri",
                "tel:+1.7035555555"
              ],
              [
                "tel",
                {
                  "type": "fax"
                },
                "uri",
                "tel:+1.7035555556"
              ]
            ]
          ],
          "entities": [
            {
              "objectClassName": "entity",
              "roles": [
                "abuse"
              ],
              "vcardArray": [
                "vcard",
                [
                  [
                    "version",
                    {},
                    "text",
                    "4.0"
                  ],
                  [
                    "fn",
                    {},
                    "text",
                    "Abuse Contact"
                  ],
                  [
                    "email",
                    {},
                    "text",
                    "abuse@organization.example"
                  ],
                  [
                    "tel",
                    {
                      "type": "voice"
                    },
                    "uri",
                    "tel:+1.7035555555"
                  ]
                ]
              ]
            }
          ]
        },
        {
          "objectClassName": "entity",
          "handle": "XXXX",
          "roles": [
            "registrant"
          ],
          "vcardArray": [
            "vcard",
            [
              [
                "version",
                {},
                "text",
                "4.0"
              ],
              [
                "fn",
                {},
                "text",
                ""
              ],
              [
                "adr",
                {},
                "text",
                [
                  "",
                  "",
                  "",
                  "",
                  "QC",
                  "",
                  "Canada"
                ]
              ]
            ]
          ]
        },
        {
          "objectClassName": "entity",
          "handle": "YYYY",
          "roles": [
            "technical"
          ],
          "vcardArray": [
            "vcard",
            [
              [
                "version",
                {},
                "text",
                "4.0"
              ],
              [
                "fn",
                {},
                "text",
                ""
              ],
              [
                "org",
                {},
                "text",
                "Example Inc."
              ],
              [
                "adr",
                {},
                "text",
                [
                  "",
                  "Suite 1234",
                  "4321 Rue Somewhere",
                  "Quebec",
                  "QC",
                  "G1V 2M2",
                  "Canada"
                ]
              ]
            ]
          ]
        }
      ],
      "events": [
        {
          "eventAction": "registration",
          "eventDate": "1997-06-03T00:00:00Z"
        },
        {
          "eventAction": "last changed",
          "eventDate": "2020-05-28T01:35:00Z"
        },
        {
          "eventAction": "expiration",
          "eventDate": "2021-06-03T04:00:00Z"
        }
      ],
      "status": [
        "server delete prohibited",
        "server update prohibited",
        "server transfer prohibited",
        "client transfer prohibited"
      ],
      "redacted": [
        {
          "name": {
            "type": "Registry Domain ID"
          },
          "path": "$.handle",
          "pathLang": "jsonpath",
          "method": "removal",
          "reason": {
            "type": "Server policy"
          }
        },
        {
          "name": {
            "type": "Registrant Name"
          },
          "path": "$.entities[?(@.roles[0]=='registrant')].
            vcardArray[1][?(@[0]=='fn')][3]",
          "pathLang": "jsonpath",
          "method": "emptyValue",
          "reason": {
            "type": "Server policy"
          }
        },
        {
          "name": {
            "type": "Registrant Organization"
          },
          "path": "$.entities[?(@.roles[0]=='registrant')].
            vcardArray[1][?(@[0]=='org')]",
          "pathLang": "jsonpath",
          "method": "removal",
          "reason": {
            "type": "Server policy"
          }
        },
        {
          "name": {
            "type": "Registrant Street"
          },
          "path": "$.entities[?(@.roles[0]=='registrant')].
            vcardArray[1][?(@[0]=='adr')][3][:3]",
          "pathLang": "jsonpath",
          "method": "emptyValue",
          "reason": {
            "type": "Server policy"
          }
        },
        {
          "name": {
            "type": "Registrant City"
          },
          "path": "$.entities[?(@.roles[0]=='registrant')].
            vcardArray[1][?(@[0]=='adr')][3][3]",
          "pathLang": "jsonpath",
          "method": "emptyValue",
          "reason": {
            "type": "Server policy"
          }
        },
        {
          "name": {
            "type": "Registrant Postal Code"
          },
          "path": "$.entities[?(@.roles[0]=='registrant')].
            vcardArray[1][?(@[0]=='adr')][3][5]",
          "pathLang": "jsonpath",
          "method": "emptyValue",
          "reason": {
            "type": "Server policy"
          }
        },
        {
          "name": {
            "type": "Registrant Email"
          },
          "path": "$.entities[?(@.roles[0]=='registrant')].
            vcardArray[1][?(@[0]=='email')]",
          "method": "removal",
          "reason": {
            "type": "Server policy"
          }
        },
        {
          "name": {
            "type": "Registrant Phone"
          },
          "path": "$.entities[?(@.roles[0]=='registrant')].
            vcardArray[1][?(@[1].type=='voice')]",
          "method": "removal",
          "reason": {
            "type": "Server policy"
          }
        },
        {
          "name": {
            "type": "Technical Name"
          },
          "path": "$.entities[?(@.roles[0]=='technical')].
            vcardArray[1][?(@[0]=='fn')][3]",
          "method": "emptyValue",
          "reason": {
            "type": "Server policy"
          }
        },
        {
          "name": {
            "type": "Technical Email"
          },
          "path": "$.entities[?(@.roles[0]=='technical')].
            vcardArray[1][?(@[0]=='email')]",
          "method": "removal",
          "reason": {
            "type": "Server policy"
          }
        },
        {
          "name": {
            "type": "Technical Phone"
          },
          "path": "$.entities[?(@.roles[0]=='technical')].
            vcardArray[1][?(@[1].type=='voice')]",
          "method": "removal",
          "reason": {
            "type": "Server policy"
          }
        },
        {
          "name": {
            "type": "Technical Fax"
          },
          "path": "$.entities[?(@.roles[0]=='technical')].
            vcardArray[1][?(@[1].type=='fax')]",
          "reason": {
            "type": "Client request",
            "description": "Client requested the field redacted"
          }
        },
        {
          "name": {
            "description": "Administrative Contact"
          },
          "path": "$.entities[?(@.roles[0]=='administrative')]",
          "method": "removal",
          "reason": {
            "description": "Refer to the technical contact"
          }
        }
        {
          "name": {
            "description": "Billing Contact"
          },
          "path": "$.entities[?(@.roles[0]=='billing')]",
          "method": "removal",
          "reason": {
            "description": "Refer to the registrant contact"
          }
        }
      ]
    }

Example unredacted version of an RDAP search response:
Unredacted RDAP Search Response

  {
    "rdapConformance": [
      "rdap_level_0"
    ],
    "domainSearchResults":[
      {
        "objectClassName": "domain",
        "handle": "ABC121",
        "ldhName": "example1.com",
        "links":[
          {
            "value":"https://example.com/rdap/domain/example1.com",
            "rel":"self",
            "href":"https://example.com/rdap/domain/example1.com",
            "type":"application/rdap+json"
          },
          {
            "value":"https://example.com/rdap/domain/example1.com",
            "rel":"related",
            "href":"https://example.com/rdap/domain/example1.com",
            "type":"application/rdap+json"
          }
        ]
      },
      {
        "objectClassName": "domain",
        "handle": "ABC122",
        "ldhName": "example2.com",
        "links":[
          {
            "value":"https://example.com/rdap/domain/example2.com",
            "rel":"self",
            "href":"https://example.com/rdap/domain/example2.com",
            "type":"application/rdap+json"
          },
          {
            "value":"https://example.com/rdap/domain/example2.com",
            "rel":"related",
            "href":"https://example.com/rdap/domain/example2.com",
            "type":"application/rdap+json"
          }
        ]
      }
    ]
  }

Example redacted version of an RDAP search response:
Redacted RDAP Search Response

  {
    "rdapConformance": [
      "rdap_level_0",
      "redacted"
    ],
    "domainSearchResults":[
      {
        "objectClassName": "domain",
        "ldhName": "example1.com",
        "links":[
          {
            "value":"https://example.com/rdap/domain/example1.com",
            "rel":"self",
            "href":"https://example.com/rdap/domain/example1.com",
            "type":"application/rdap+json"
          },
          {
            "value":"https://example.com/rdap/domain/example1.com",
            "rel":"related",
            "href":"https://example.com/rdap/domain/example1.com",
            "type":"application/rdap+json"
          }
        ],
        "redacted": [
          {
            "name": {
              "type": "Registry Domain ID"
            },
            "path": "$.domainSearchResults[0].handle",
            "pathLang": "jsonpath",
            "method": "removal",
            "reason": {
              "type": "Server policy"
            }
          }
        ]
      },
      {
        "objectClassName": "domain",
        "ldhName": "example2.com",
        "links":[
          {
            "value":"https://example.com/rdap/domain/example2.com",
            "rel":"self",
            "href":"https://example.com/rdap/domain/example2.com",
            "type":"application/rdap+json"
          },
          {
            "value":"https://example.com/rdap/domain/example2.com",
            "rel":"related",
            "href":"https://example.com/rdap/domain/example2.com",
            "type":"application/rdap+json"
          }
        ],
        "redacted": [
          {
            "name": {
              "type": "Registry Domain ID"
            },
            "path": "$.domainSearchResults[1].handle",
            "pathLang": "jsonpath",
            "method": "removal",
            "reason": {
              "type": "Server policy"
            }
          }
        ]
      }
    ]
  }

JSONPath Considerations
JSONPath is the default JSON path expression language. This section covers considerations for servers using [I-D.ietf-jsonpath-base] to identify redacted RDAP fields with the "path" member of redacted objects in the "redacted" member. The list of JSONPath considerations include:
1. Use absolute paths with the '$' JSONPath element. An example is "$.handle" for the "Registry Domain ID" in a lookup response or "$.domainSearchResults[0].handle" in a search response.
2. Validate a JSONPath expression using a non-redacted RDAP response, where evaluating the expression results in returning the redacted field.
3. Reference the removed object field when redacting an entire object by the Redaction by Removal Method, where all of the object's child fields are explicitly removed. An example is "$.entities[?(@.roles[0]=='administrative')]" for the entire "Administrative Contact".
4. When an entity has multiple roles, include "redacted" members for each role using the role index. This will result in duplicate "redacted" members, but will enable the client to treat redaction consistently when there is a single role per entity or multiple roles per entity. An example is when the "roles" member has the value '["registrant","administrative"]', redacting the "name" member of the entity will result in two "redacted" members with the JSONPath expressions "$.entities[?(@.roles[0]=='registrant')].vcardArray[1][?(@[0]=='fn')][3]" and "$.entities[?(@.roles[1]==’administrative’)].vcardArray[1][?(@[0]=='fn')][3]".
5. When there are multiple entities with the same role, include “redacted” members for each entity using the entity index instead of the role. A JSONPath can be created that identifies the entity based on an index of a role selector nodelist, such as “$.entities[?(@.roles[0]=='technical')][0]” for the first entity with the “technical” role. Using the entity index, such as “$.entities[1]”, is simpler and recommended.
6. Reference the removed field when using the Redaction by Removal Method. An example is "$.handle" for the "Registry Domain ID".
7. Reference index 0 of the jCard property array, which is the jCard "name" property, with a filter expression containing the name of the field, when redacting a jCard field using the Redaction by Removal Method. An example is "$.entities[?(@.roles[0]=='registrant')].vcardArray[1][?(@[0]=='email')]" for the "Registrant Email".
8. Reference jCard field value or values redacted by array index 3 and greater, when redacting a jCard field using the Redaction by Empty Value Method. The jCard property array index 3 and greater contain the property values, where the property values set with an empty value are referenced directly in place of the jCard property name. Servers can then systematically redact jCard field value or values based on the JSONPath expressions and clients will directly know which jCard property values have been redacted. An example is "$.entities[?(@.roles[0]=='registrant')].vcardArray[1][?(@[0]=='fn')][3]" for the "Registrant Name" or "$.entities[?(@.roles[0]=='registrant')].vcardArray[1][?(@[0]=='adr')][3][5]" for the "Registrant Postal Code".
9. RDAP extensions should define any special JSONPath considerations required to identify redacted RDAP fields if these considerations are insufficient.
IANA Considerations
RDAP Extensions Registry
IANA is requested to register the following value in the RDAP Extensions Registry:
Extension identifier:
redacted
Registry operator:
Any
Published specification:
This document.
Contact:
IESG <iesg@ietf.org>
Intended usage:
This extension identifies the redacted fields in an RDAP response.
JSON Values Registry
Section 10.2 of [RFC9083] defines the JSON Values Registry with pre-defined Type field values and the use of the "Expert Review" policy defined in [RFC8126]. Two new JSON Values Registry Type field values are used to register pre-defined redacted name and reason values:
"redacted name":
Redacted name being registered. The registered redacted name is referenced using the "type" field of the redacted "name" field.
"redacted reason":
Redacted reason being registered. The registered redacted reason is referenced using the "type" field of the redacted "reason" field.
Implementation Status
Note to RFC Editor: Please remove this section and the reference to RFC 7942 before publication.
This section records the status of known implementations of the protocol defined by this specification at the time of posting of this Internet-Draft, and is based on a proposal described in RFC 7942. The description of implementations in this section is intended to assist the IETF in its decision processes in progressing drafts to RFCs. Please note that the listing of any individual implementation here does not imply endorsement by the IETF. Furthermore, no effort has been spent to verify the information presented here that was supplied by IETF contributors. This is not intended as, and must not be construed to be, a catalog of available implementations or their features. Readers are advised to note that other implementations may exist.
According to RFC 7942, "this will allow reviewers and working groups to assign due consideration to documents that have the benefit of running code, which may serve as evidence of valuable experimentation and feedback that have made the implemented protocols more mature. It is up to the individual working groups to use this information as they see fit".
IIT-CNR/Registro.it RDAP Server
Responsible Organization: Institute of Informatics and Telematics of National Research Council (IIT-CNR)/Registro.it
Location: https://rdap.pubtest.nic.it/
Description: This implementation includes support for RDAP queries using data from the public test environment of .it ccTLD. The "redacted" array can be returned in the response to the domain lookup that is the only available to anonymous users.
Level of Maturity: This is an "alpha" test implementation.
Coverage: This implementation includes all of the features described in this specification.
Contact Information: Mario Loffredo, mario.loffredo@iit.cnr.it
Security Considerations
The server including a redacted signal provides an unauthorized client additional information related to the existence of data. Servers MAY exclude the redacted members for RDAP fields that are considered a privacy issue in providing a data existence signal.
Acknowledgements
The authors wish to thank the following persons for their feedback and suggestions: Marc Blanchet, Scott Hollenbeck, Mario Loffredo, Gustavo Lozano, and Rick Wilhelm.
References
Informative References
Normative References
[RFC9083]
[RFC9082]
[I-D.ietf-jsonpath-base]
[RFC8259]
[RFC2119]
[RFC8174]
[RFC6350]
[RFC8605]
[RFC8126]
Change History
Change from 00 to 01
1. Changed rdapConformance to use pointed "redacted_0.1" value to support structural changes of the extension up to the target of "redacted_1.0".
2. Updates based on the Gustavo Lozano feedback:
  1. Updated the language to change the special treatment of jCard to be more generic for future RDAP extensions that leverage fixed length JSON arrays.
  2. Added "RDAP extensions should define any special JSONPath considerations required to identify redacted RDAP fields if the these considerations are insufficient." to the JSONPath Considerations section to generalize it.
3. Updates based on the Marc Blanchet feedback:
  1. Added a reference to draft-ietf-regext-rdap-jscontact as an example of an RDAP extension that is suited for the Redaction by Removal Method based on the lack of dependency on positional JSON arrays.
  2. Added support for registered and unregistered (free-form) redaction reasons by changing the "reason" property to be a JSON object with the "type" and "description" properties. The "type" property includes registration in the IANA JSON Values Registry.
  3. Added a "JSON Values Registry" section in the IANA Considersations section to define the "redaction reason" JSON Values Registry Type values to support the registration of redaction reasons.
4. Updates based on the Mario Loffredo feedback:
  1. Added support for registered and unregistered (free-form) redaction names by changing the "reason" property to be a JSON object with the "type" and "description" properties. The "type" property includes registration in the IANA JSON Values Registry.
  2. Added a "JSON Values Registry" section in the IANA Considersations section to define the "redaction name" JSON Values Registry Type values to support the registration of redaction names.
  3. Added a JSONPath Considerations item associated with handling entities with multiple roles.
  4. Added language to restrict the extension to responses.
Change from 01 to 02
1. Updates to add support for RDAP search responses:
  1. Replaced "RDAP lookup response" with "RDAP response" throughout the draft to expand the scope to include search.
  2. Updated the description in the second paragraph of the Introduction to cover both a lookup response and a search response.
  3. Added an example of the use of an absoluate path for a search response to the "JSONPath Considerations" section.
  4. Added a description of the placement of the "redacted" member in a lookup response and a search response in the ""redacted" Member" section.
  5. Added an example of an unredacted search response and a redacted search response in the ""redacted" Member" section.
Change from 02 to 03
1. Fixed mismatch of the extension identifier, which was updated to "redacted_0.1" throughout the draft based on feedback from Mario Loffredo.
2. Added the JSONPath Considerations item associated with redacting fields for multiple entities with the same role based on implementation feedback from Mario Loffredo.
3. Added the Implementation Status section that includes the server implementation by Mario Loffredo.
4. Added use of numbered figures for easy reference for JSON Values Registry registrations.
5. Updated the example unredacted and redacted lookup responses to include the "objectClassName" and "handle" members.
6. Changed RFC7482 and RFC7483 references to RFC9082 and RFC9083, respectively.
Change from 03 to 04
1. Changed the extension identifier to be "redacted" instead of a versioned value, which will be leveraged for both the rdapConformance value and the JSON Values.
2. Changed the RDAP Conformance to be "redacted_level_0.2", which leveraged the extension identifier as a prefix along with "_level_" and a pointed version number. The version number will become "1.0" once the draft passes WGLC.
3. Added the Redaction by Replacement Value Method.
Change from 04 to 05
1. Update the RDAP Extensions Registry entries to include the identifier that is used for the RDAP conformance value and to include the "redacted" prefix indentifier to use for the JSON response member.
2. Changed the RDAP Conformance to be "redacted_level_0_3", which is registered in the RDAP Extensions Registry. The RDAP Conformance value will become "redacted_level_1" once the draft passes WGLC.
Change from 05 to 06
1. Fixed a couple nits.
2. Updated the Redaction by Replacement Value Method email web form examples to use the "contact-uri" jCard property of RFC 8605.
Change from 06 to 07
1. Added the optional replacementPath child member for use with the Redaction by Replacement Value Method.
Change from 07 to 08
1. Updates based on the Rick Wilhelm feedback:
  1. Updated the definition of a redacted RDAP field in the Introduction section.
  2. Updated the reference to three methods instead of two in the Redaction Methods section.
  3. Created a new paragraph for the example in the Redaction by Removal Method section.
  4. Explicity specified one or more redacted fields for inclusion of the "redacted" member in the "redacted" Member section.
  5. Updated the description of the "method" member in the "redacted" Member section.
Change from 08 to 09
1. Updated the RDAP extensions Registry registration and RDAP conformance to match the working group consensus that does not include a version with "redacted".